<script setup>
import {ref, computed, watch} from 'vue'
import axios from 'axios'
import {parseDate} from '@/utils';

const props = defineProps({
  startDate: Date,
  endDate: Date,
  promotions: Array,
  currentPromotion: String,
  places: Array,
  employees: Array,
  subjects: Array
})
const pPlaces = computed(() => props.places)
const pEmployees = computed(() => props.employees)
const pStartDate = computed(() => props.startDate)
const pEndDate = computed(() => props.endDate)
const pPromotions = computed(() => props.promotions)
const pSubjects = computed(() => props.subjects)

const startDateParsed = computed(() => parseDate(pStartDate.value))
const endDateParsed = computed(() => parseDate(pEndDate.value))
const startDate = ref(startDateParsed)
const endDate = ref(endDateParsed)

const pCurrentPromotion = computed(() => {
  console.log(props.currentPromotion)
  if (props.currentPromotion === undefined)
    return []

  return [parseInt(props.currentPromotion)]
})

const selectedPromotions = ref(pCurrentPromotion.value)
watch(pCurrentPromotion, newv => {
  selectedPromotions.value = newv
})

const selectableSubjects = ref([])
watch(selectedPromotions, newv => {
  selectableSubjects.value = pSubjects.value.filter(
      sub => newv.some(prom => prom === sub.id_promotion)
  )
})


const selectedSubject = ref()
const selectedEmployees = ref([])
const selectedPlace = ref()

const canSubmit = computed(() =>
       selectedPromotions.value.length !== 0
    && selectedSubject.value !== undefined
    && selectedEmployees.value.length !== 0
    && selectedPlace.value !== undefined
    && startDate.value !== undefined && endDate.value !== undefined
)

const infoValid = "Timeslot created!"
const infoText = ref('')

const emit = defineEmits(['exit'])




function createTimeslot() {
  axios.post(`${import.meta.env.VITE_GESTION_EDT_API_URL}/creneaux/`, {
    headers: {
      'Content-Type': 'application/json',
      'Accept': 'application/json'
    },
    timeslotIdDTO: 0,
    placeIdDTO: selectedPlace.value,
    employeeIdsDTO: selectedEmployees.value,
    promotionIdsDTO: selectedPromotions.value,
    materialIdDTO: selectedSubject.value,
    startDateDTO: startDateParsed.value,
    endDateDTO: endDateParsed.value
  })
      .then(() => {
        infoText.value = infoValid
        setTimeout(() => {
          emit('exit')
        }, 2000)
      })
      .catch(e => {
        infoText.value = 'Error creating timeslot!'
      })

  selectedSubject.value = undefined
  selectedEmployees.value = []
  selectedPlace.value = undefined
}
</script>

<template>
  <div class="create">
    <form class="mb-4">
      <!-- DATES -->
      <div class="form-group">
        <label for="startDate">Start Date</label>
        <input type="datetime-local" id="startDate" class="form-control" v-model="startDate">
      </div>
      <div class="form-group">
        <label for="endDate">End Date</label>
        <input type="datetime-local" id="endDate" class="form-control" v-model="endDate">
      </div>

      <!-- PROMOTIONS -->
      <div class="form-group">
        <label for="promotion">Promotion</label>
        <div class="form-check" v-for="promotion in pPromotions" :key="promotion.id">
          <input type="checkbox" :id="promotion.intitule" :value="promotion.id" class="form-check-input"
                 v-model="selectedPromotions">
          <label :for="promotion.intitule" class="form-check-label">{{ promotion.intitule }}</label>
        </div>
      </div>

      <!-- SUBJECTS -->
      <div class="form-group">
        <label for="subject">Subject</label>
        <select id="subject" class="form-control" v-model="selectedSubject" :disabled="selectableSubjects.length === 0">
          <option v-for="subject in selectableSubjects" :key="subject.id" :value="subject.id">{{
              subject.intitule
            }}
          </option>
        </select>
      </div>

      <!-- EMPLOYEES -->
      <div class="form-group">
        <label for="employee">Employee</label>
        <div class="form-check" v-for="employee in pEmployees" :key="employee.id">
          <input type="checkbox" :id="employee.id" :value="employee.id" class="form-check-input"
                 v-model="selectedEmployees">
          <label :for="employee.id" class="form-check-label">{{ employee.nom }} {{ employee.prenom }}</label>
        </div>
      </div>

      <!-- PLACES -->
      <div class="form-group">
        <label for="place">Place</label>
        <select id="place" class="form-control" v-model="selectedPlace">
          <option v-for="place in pPlaces" :key="place.placeIdDTO" :value="place.placeIdDTO">
            {{ place.roomDTO }} - {{ place.buildingDTO }}
          </option>
        </select>
      </div>

      <!-- SUBMIT -->
      <button type="submit" class="btn btn-primary" @click.prevent="createTimeslot" :disabled="!canSubmit">Create</button>
      <p class="mt-3" :class="infoText === infoValid ? 'text-success' : 'text-danger'">{{ infoText }}</p>
    </form>
  </div>
</template>

<style scoped>
.form-group {
  margin-bottom: 1rem;
}
</style>
